/* 
 * scientific visualization api for direct framebuffer
 *
 * author: hackbard@hackdaworld.dyndns.org
 *
 */

#ifndef DFBAPI_H
#define DFBAPI_H

#ifdef USE_DFB_API
#include <directfb.h>
#endif

/* two dimensional lattice */

#define X_GAP 5
#define Y_GAP X_GAP
#define RED 1

typedef struct __d2_lattice
{
 int max_x,max_y;
 int s_height,s_width;
 int fakt_x,fakt_y;
 int info_x,info_y;
 int info_w,info_h;
 int font_h;
 unsigned char *status; /* status&1 -> red, else blue */
 int *extra; /* store extra values */
 void *v_ptr; /* void ptr, for any use */
#ifdef USE_DFB_API
 IDirectFB *dfb;
 IDirectFBSurface *p_surface;
 IDirectFBFont *font;
 IDirectFBInputDevice *keyboard;
 IDirectFBEventBuffer *k_buffer;
#else
 char *foo1,*foo2,*foo3,*foo4,*foo5;
#endif
} d2_lattice;

typedef struct __d3_lattice
{
 int max_x,max_y,max_z;
 int s_height,s_width;
 int fakt_x,fakt_y;
 int info_x,info_y;
 int info_w,info_h;
 int font_h;
 unsigned char *status; /* status&1 -> red, else blue */
 int *extra; /* store extra values */
 void *v_ptr; /* void ptr, for any use */
#ifdef USE_DFB_API
 IDirectFB *dfb;
 IDirectFBSurface *p_surface;
 IDirectFBFont *font;
 IDirectFBInputDevice *keyboard;
 IDirectFBEventBuffer *k_buffer;
#else
 char *foo1,*foo2,*foo3,*foo4,*foo5;
#endif
} d3_lattice;

/* function prototypes */
int d2_lattice_init(int *argc,char **argv,d2_lattice *d2_l);
int d2_lattice_release(d2_lattice *d2_l);
int d2_lattice_draw(d2_lattice *d2_l,int x,int y,int arg_c,char **arg_v,unsigned char mode,int max_extra);
int d3_lattice_init(int *argc,char **argv,d3_lattice *d3_l);
int d3_lattice_release(d3_lattice *d3_l);
int d3_lattice_draw(d3_lattice *d3_l,int x,int y,int z,int arg_c,char **arg_v,unsigned char mode,int max_extra);
int d2_event_init(d2_lattice *d2_l);
int d3_event_init(d3_lattice *d3_l);
int scan_event(d3_lattice *d3_l,int *x,int *y,int *z,int *q,int *esc,int *switchmode,int *bmp);
int dx_lattice_get_color(unsigned char *status,unsigned char *r,unsigned char *g,unsigned char *b,unsigned char mode);

#endif /* DFBAPI_H */
